# %% bcmfR R-source %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
# _________________________________________________________________________
#
#    bcmf_data_25.R
# _________________________________________________________________________
#
# %%



# === [BuildTest_Aqueous] ====================
# --- FINAL bcmfR
# --- builds TEST.Aqueous.Param from .csvy datafile
BuildTest_Aqueous <- function(file.aqueous.csvy) {
  
  yamlhead <- csvy::get_yaml_header(file.aqueous.csvy)
  
  yamlvars <- yaml::read_yaml(text = yamlhead)
  
  test.aqueous.value <- c(yamlvars$cwater$value,
                          yamlvars$tstart$value,
                          yamlvars$tdepur$value,
                          yamlvars$tend$value,
                          yamlvars$kgrowth$value,
                          yamlvars$lipidfish$value)
  
  test.aqueous.unit <- c(yamlvars$cwater$unit,
                         yamlvars$tstart$unit,
                         yamlvars$tdepur$unit,
                         yamlvars$tend$unit,
                         yamlvars$kgrowth$unit,
                         yamlvars$lipidfish$unit)
                          
  
  # #-- get the attributes
  # test.aqueous.read <- attributes(dataframe.aqueous.csvy)
  # 
  # 
  # test.aqueous.value <- c(test.aqueous.read$cwater$value,
  #                         test.aqueous.read$tstart$value,
  #                         test.aqueous.read$tdepur$value,
  #                         test.aqueous.read$tend$value,
  #                         test.aqueous.read$kgrowth$value,
  #                         test.aqueous.read$lipidfish$value)
  # 
  # 
  # 
  # test.aqueous.unit <- c(test.aqueous.read$cwater$unit,
  #                        test.aqueous.read$tstart$unit,
  #                        test.aqueous.read$tdepur$unit,
  #                        test.aqueous.read$tend$unit,
  #                        test.aqueous.read$kgrowth$unit,
  #                        test.aqueous.read$lipidfish$unit)
  # 
 
  
  test.aqueous.names <- c("cwater",
                          "tstart",
                          "tdepur",
                          "tend",
                          "kgrowth",
                          "lipidfish")
  
 
  
  # names(test.aqueous.value) <- test.aqueous.names
  # names(test.aqueous.unit)  <- test.aqueous.names
  # 
  
  # assign("TEST.Aqueous.num", test.aqueous.value, envir = .GlobalEnv)
  # assign("TEST.Aqueous.Unit",  test.aqueous.unit,  envir = .GlobalEnv)
  
  test.aqueous.param <- data.frame(value = test.aqueous.value,
                                   unit  = test.aqueous.unit,
                                   row.names  = test.aqueous.names,
                                   stringsAsFactors = FALSE)
  
  
  assign("TEST.Aqueous.Design", test.aqueous.param, envir = .GlobalEnv)
  
  #assign("@TEST", "Aqueous", envir = .GlobalEnv)

  test.aqueous.meas.name <- c(yamlvars$time$name, yamlvars$cfish$name)
  
  test.aqueous.meas.unit <- c(yamlvars$time$unit, yamlvars$cfish$unit)
  
  test.aqueous.meas.var  <- c("time", "cfish")
  
  # test.aqueous.meas.name <- c(test.aqueous.read$time$name,
  #                             test.aqueous.read$cfish$name)
  # test.aqueous.meas.unit <- c(test.aqueous.read$time$unit,
  #                             test.aqueous.read$cfish$unit)
  # test.aqueous.meas.var  <- c("time", "cfish")
   
  # test.aqueous.meas <- data.frame(name = test.aqueous.meas.name,
  #                                 unit = test.aqueous.meas.unit,
  #                                 row.names  = test.aqueous.meas.var,
  #                                 stringsAsFactors = FALSE)
  
  test.aqueous.meas <- data.frame(name = test.aqueous.meas.name,
                                  unit = test.aqueous.meas.unit,
                                  row.names  = test.aqueous.meas.var,
                                  stringsAsFactors = FALSE)
  # 
  assign("TEST.Aqueous.Measured", test.aqueous.meas, envir = .GlobalEnv)
  # 
    
  # return(test.aqueous.param)
  
}
# ___ (BuildTest_Aqueous) ____________________



# === [BuildTest_Dietary] ====================
# --- FINAL bcmfR
# --- builds TEST.Dietary.Param from .csvy datafile
BuildTest_Dietary <- function(file.dietary.csvy) {
  
  yamlhead <- csvy::get_yaml_header(file.dietary.csvy)
  
  yamlvars <- yaml::read_yaml(text = yamlhead)
  
  test.dietary.value <- c(yamlvars$cfood$value,
                          yamlvars$ingestion$value,
                          yamlvars$tfeed$value,
                          yamlvars$lipidfood$value,
                          yamlvars$lipidfish$value,
                          yamlvars$tdepur$value,
                          yamlvars$tend$value,
                          yamlvars$kgrowth$value)
  
  test.dietary.unit <- c(yamlvars$cfood$unit,
                         yamlvars$ingestion$unit,
                         yamlvars$tfeed$unit,
                         yamlvars$lipidfood$unit,
                         yamlvars$lipidfish$unit,
                         yamlvars$tdepur$unit,
                         yamlvars$tend$unit,
                         yamlvars$kgrowth$unit)
  
  #-- get the attributes
  # test.dietary.read <- attributes(dataframe.dietary.csvy)
  # 
  # test.dietary.value <- c(test.dietary.read$cfood$value,
  #                         test.dietary.read$ingestion$value,
  #                         test.dietary.read$tfeed$value,
  #                         test.dietary.read$lipidfood$value,
  #                         test.dietary.read$lipidfish$value,
  #                         test.dietary.read$tdepur$value,
  #                         test.dietary.read$tend$value,
  #                         test.dietary.read$kgrowth$value)
  # 
  # test.dietary.unit <- c(test.dietary.read$cfood$unit,
  #                        test.dietary.read$ingestion$unit,
  #                        test.dietary.read$tfeed$unit,
  #                        test.dietary.read$lipidfood$unit,
  #                        test.dietary.read$lipidfish$unit,
  #                        test.dietary.read$tdepur$unit,
  #                        test.dietary.read$tend$unit,
  #                        test.dietary.read$kgrowth$unit)
  
  
  test.dietary.names <- c("cfood",
                          "ingestion",
                          "tfeed",
                          "lipidfood",
                          "lipidfish",
                          "tdepur",
                          "tend",
                          "kgrowth")
  
  # names(test.dietary.value) <- test.dietary.names
  # names(test.dietary.unit)  <- test.dietary.names
 
  # assign("TEST.Dietary.num", test.dietary.value, envir = .GlobalEnv)
  # assign("TEST.Dietary.Unit",  test.dietary.unit,  envir = .GlobalEnv)
  
  
  test.dietary.param <- data.frame(value = test.dietary.value,
                                   unit  = test.dietary.unit,
                                   row.names  = test.dietary.names,
                                   stringsAsFactors = FALSE)
  
  assign("TEST.Dietary.Design", test.dietary.param, envir = .GlobalEnv)
  
  
  test.dietary.meas.name <- c(yamlvars$time$name, yamlvars$cfish$name)
  
  test.dietary.meas.unit <- c(yamlvars$time$unit, yamlvars$cfish$unit)
  
  test.dietary.meas.var  <- c("time", "cfish")
  
  test.dietary.meas <- data.frame(name = test.dietary.meas.name,
                                  unit = test.dietary.meas.unit,
                                  row.names  = test.dietary.meas.var,
                                  stringsAsFactors = FALSE)
  
  assign("TEST.Dietary.Measured", test.dietary.meas, envir = .GlobalEnv)
  
  
  # return(test.dietary.param)
  
}
# ___ (BuildTest_Dietary) ____________________



# === [ClearTest_Aqueous] ====================
ClearTest_Aqueous <- function() {

  # if (exists("@TEST.Type", envir = .GlobalEnv) &&
  #     get("@TEST.Type", envir = .GlobalEnv) == "Aqueous") {
  #   
  #   # SAVE SESSION RDATA
  #   
  #   save.image(file = "Saved-01-Aqueous.RData")
  #     
    
  if (get("@TEST.Type", envir = .GlobalEnv) == "Aqueous") {
    
    # RUN.State = RUN.State + 1?
    
    save.image(file = "@TEST.LAST-Aqueous.RData")
    
  } else {
    
    if (get("@TEST.Type", envir = .GlobalEnv) == "Dietary") {
    
      save.image(file = "@TEST.LAST-Dietary.RData")}
    
  }
    
  # REMOVE ALL GLOBALS (Aqueous)
  
  ### BCF.BestFit
    
  if (exists("BCF.BestFit", envir = .GlobalEnv)) {
      rm("BCF.BestFit", envir = .GlobalEnv)
  }
  
  if (exists("BCF.BestFit.BoxCox", envir = .GlobalEnv)) {
    rm("BCF.BestFit.BoxCox", envir = .GlobalEnv)
  }
  
  if (exists("BCF.BestFit.Ln", envir = .GlobalEnv)) {
    rm("BCF.BestFit.Ln", envir = .GlobalEnv)
  }
  
  
  ### BCF.ConfFit
  
  if (exists("BCF.ConfFit", envir = .GlobalEnv)) {
    rm("BCF.ConfFit", envir = .GlobalEnv)
  }
  
  if (exists("BCF.ConfFit.BoxCox", envir = .GlobalEnv)) {
    rm("BCF.ConfFit.BoxCox", envir = .GlobalEnv)
  }
  
  if (exists("BCF.ConfFit.Ln", envir = .GlobalEnv)) {
    rm("BCF.ConfFit.Ln", envir = .GlobalEnv)
  }
  
  
  ### BCF.LambdaEst
  
  if (exists("BCF.LambdaEst", envir = .GlobalEnv)) {
    rm("BCF.LambdaEst", envir = .GlobalEnv)
  }


  ### BCF.ModelFit
  
  if (exists("BCF.ModelFit", envir = .GlobalEnv)) {
      rm("BCF.ModelFit", envir = .GlobalEnv)
  }
    
  if (exists("BCF.ModelFit.BoxCox", envir = .GlobalEnv)) {
    rm("BCF.ModelFit.BoxCox", envir = .GlobalEnv)
  }
  
  if (exists("BCF.ModelFit.Ln", envir = .GlobalEnv)) {
    rm("BCF.ModelFit.Ln", envir = .GlobalEnv)
  }
  

  ### BCF.ParamBoot
  
  if (exists("BCF.ParamBoot", envir = .GlobalEnv)) {
    rm("BCF.ParamBoot", envir = .GlobalEnv)
  }
  
  if (exists("BCF.ParamBoot.BoxCox", envir = .GlobalEnv)) {
    rm("BCF.ParamBoot.BoxCox", envir = .GlobalEnv)
  }
  
  if (exists("BCF.ParamBoot.Ln", envir = .GlobalEnv)) {
    rm("BCF.ParamBoot.Ln", envir = .GlobalEnv)
  }

  
  ### BCF.ParamFit
  
  if (exists("BCF.ParamFit", envir = .GlobalEnv)) {
    rm("BCF.ParamFit", envir = .GlobalEnv)
  }
  
  if (exists("BCF.ParamFit.BoxCox", envir = .GlobalEnv)) {
    rm("BCF.ParamFit.BoxCox", envir = .GlobalEnv)
  }
  
  if (exists("BCF.ParamFit.BoxCox.Lambda", envir = .GlobalEnv)) {
    rm("BCF.ParamFit.BoxCox.Lambda", envir = .GlobalEnv)
  }
  
  if (exists("BCF.ParamFit.Ln", envir = .GlobalEnv)) {
    rm("BCF.ParamFit.Ln", envir = .GlobalEnv)
  }
  

  ### BCF.ParamFit.Lambda
  
  if (exists("BCF.ParamFit.Lambda", envir = .GlobalEnv)) {
    rm("BCF.ParamFit.Lambda", envir = .GlobalEnv)
  }
  

  ### BCF.StartFit (ONLY ONE!!)
  
  if (exists("BCF.StartFit", envir = .GlobalEnv)) {
    rm("BCF.StartFit", envir = .GlobalEnv)
  }
  
  
  ### BCF.SummTable
  
  if (exists("BCF.SummTable", envir = .GlobalEnv)) {
    rm("BCF.SummTable", envir = .GlobalEnv)
  }
  
  if (exists("BCF.SummTable.BoxCox", envir = .GlobalEnv)) {
    rm("BCF.SummTable.BoxCox", envir = .GlobalEnv)
  }
  
  if (exists("BCF.SummTable.Ln", envir = .GlobalEnv)) {
    rm("BCF.SummTable.Ln", envir = .GlobalEnv)
  }
  
  
  ### DATA.Aqueous
  
  if (exists("DATA.Aqueous.Work", envir = .GlobalEnv)) {
    rm("DATA.Aqueous.Work", envir = .GlobalEnv)
  }
  
  if (exists("DATA.Aqueous.1.Uptake", envir = .GlobalEnv)) {
    rm("DATA.Aqueous.1.Uptake", envir = .GlobalEnv)
  }
  
  if (exists("DATA.Aqueous.2.Depur", envir = .GlobalEnv)) {
    rm("DATA.Aqueous.2.Depur", envir = .GlobalEnv)
  }
  

  ### TEST.Aqueous.Design & .Measured
  
  if (exists("TEST.Aqueous.Design", envir = .GlobalEnv)) {
    rm("TEST.Aqueous.Design", envir = .GlobalEnv)
  }
  
  if (exists("TEST.Aqueous.Measured", envir = .GlobalEnv)) {
    rm("TEST.Aqueous.Measured", envir = .GlobalEnv)
  }
  
  if (exists("@TEST.Data", envir = .GlobalEnv)) {
    assign("@TEST.Data", "", envir = .GlobalEnv)
  }

  if (exists("@TEST.Type", envir = .GlobalEnv)) {
    assign("@TEST.Type", "", envir = .GlobalEnv)
    }

}
# ___ (ClearTest_Aqueous) ____________________



# === [ClearTest_Dietary] ====================
ClearTest_Dietary <- function() {
  
  # if (exists("@TEST.Type", envir = .GlobalEnv) &&
  #     get("@TEST.Type", envir = .GlobalEnv) == "Dietary") {
  #   
  #  save.image(file = "Saved-01-Dietary.RData")
  
  
  if (get("@TEST.Type", envir = .GlobalEnv) == "Aqueous") {
    
    # RUN.State = RUN.State + 1?
    
    save.image(file = "@TEST.LAST-Aqueous.RData")
    
  } else {
    
    if (get("@TEST.Type", envir = .GlobalEnv) == "Dietary") {
      
      save.image(file = "@TEST.LAST-Dietary.RData")}
    
  }
  
    
  # rm all globals
    
  
  ### BMF.BestFit
  
  if (exists("BMF.BestFit", envir = .GlobalEnv)) {
    rm("BMF.BestFit", envir = .GlobalEnv)
  }
  
  if (exists("BMF.BestFit.BoxCox", envir = .GlobalEnv)) {
    rm("BMF.BestFit.BoxCox", envir = .GlobalEnv)
  }
  
  if (exists("BMF.BestFit.Ln", envir = .GlobalEnv)) {
    rm("BMF.BestFit.Ln", envir = .GlobalEnv)
  }
  
  
  ### BMF.ConfFit
  
  if (exists("BMF.ConfFit", envir = .GlobalEnv)) {
    rm("BMF.ConfFit", envir = .GlobalEnv)
  }
  
  if (exists("BMF.ConfFit.BoxCox", envir = .GlobalEnv)) {
    rm("BMF.ConfFit.BoxCox", envir = .GlobalEnv)
  }
  
  if (exists("BMF.ConfFit.Ln", envir = .GlobalEnv)) {
    rm("BMF.ConfFit.Ln", envir = .GlobalEnv)
  }
  
  
  ### BMF.LambdaEst
  
  if (exists("BMF.LambdaEst", envir = .GlobalEnv)) {
    rm("BMF.LambdaEst", envir = .GlobalEnv)
  }
  
  ### BMF.ModelFit
  
  if (exists("BMF.ModelFit", envir = .GlobalEnv)) {
    rm("BMF.ModelFit", envir = .GlobalEnv)
  }
  
  if (exists("BMF.ModelFit.BoxCox", envir = .GlobalEnv)) {
    rm("BMF.ModelFit.BoxCox", envir = .GlobalEnv)
  }
  
  if (exists("BMF.ModelFit.Ln", envir = .GlobalEnv)) {
    rm("BMF.ModelFit.Ln", envir = .GlobalEnv)
  }
  
  
  ### BMF.ParamBoot
  
  if (exists("BMF.ParamBoot", envir = .GlobalEnv)) {
    rm("BMF.ParamBoot", envir = .GlobalEnv)
  }
  
  if (exists("BMF.ParamBoot.BoxCox", envir = .GlobalEnv)) {
    rm("BMF.ParamBoot.BoxCox", envir = .GlobalEnv)
  }
  
  if (exists("BMF.ParamBoot.Ln", envir = .GlobalEnv)) {
    rm("BMF.ParamBoot.Ln", envir = .GlobalEnv)
  }
  
  
  ### BMF.ParamFit
  
  if (exists("BMF.ParamFit", envir = .GlobalEnv)) {
    rm("BMF.ParamFit", envir = .GlobalEnv)
  }
  
  if (exists("BMF.ParamFit.BoxCox", envir = .GlobalEnv)) {
    rm("BMF.ParamFit.BoxCox", envir = .GlobalEnv)
  }
  
  if (exists("BMF.ParamFit.Ln", envir = .GlobalEnv)) {
    rm("BMF.ParamFit.Ln", envir = .GlobalEnv)
  }
  
  
  ### BMF.ParamFit.Lambda
  
  if (exists("BMF.ParamFit.Lambda", envir = .GlobalEnv)) {
    rm("BMF.ParamFit.Lambda", envir = .GlobalEnv)
  }
  
  ### BMF.StartFit
  
  if (exists("BMF.StartFit", envir = .GlobalEnv)) {
    rm("BMF.StartFit", envir = .GlobalEnv)
  }
  
  
  ### BMF.SummTable
  
  if (exists("BMF.SummTable", envir = .GlobalEnv)) {
    rm("BMF.SummTable", envir = .GlobalEnv)
  }
  
  if (exists("BMF.SummTable.BoxCox", envir = .GlobalEnv)) {
    rm("BMF.SummTable.BoxCox", envir = .GlobalEnv)
  }
  
  if (exists("BMF.SummTable.Ln", envir = .GlobalEnv)) {
    rm("BMF.SummTable.Ln", envir = .GlobalEnv)
  }
  
  
  ### DATA.Dietary.Work
  
  if (exists("DATA.Dietary.Work", envir = .GlobalEnv)) {
    rm("DATA.Dietary.Work", envir = .GlobalEnv)
  }
  
  
  ### TEST.Dietary.Design & .Measured
  
  if (exists("TEST.Dietary.Design", envir = .GlobalEnv)) {
    rm("TEST.Dietary.Design", envir = .GlobalEnv)
  }
  
  if (exists("TEST.Dietary.Measured", envir = .GlobalEnv)) {
    rm("TEST.Dietary.Measured", envir = .GlobalEnv)
  }
  
  if (exists("@TEST.Data", envir = .GlobalEnv)) {
    assign("@TEST.Data", "", envir = .GlobalEnv)
  }
  
  if (exists("@TEST.Type", envir = .GlobalEnv)) {
    assign("@TEST.Type", "", envir = .GlobalEnv)
  }
}
# ___ (ClearTest_Dietary) ____________________



# === [dataCFish_Summary] ====================
dataCFish_Summary <- function(dataframe) {
  
  # if (is.null(dataframe)) {
  #   
  #   #-- get dataframe type from TEST.Type
  #   if (get("@TEST", envir = .GlobalEnv) == "Aqueous TEST Loaded") {
  #     
  #     dataframe <- get("DATA.Aqueous.Work", envir = .GlobalEnv)
  #     
  #   } else {
  #     
  #     # assume these are the only current TEST.Types
  #     dataframe <- get("DATA.Dietary.Work", envir = .GlobalEnv)
  #   }
  # }
  
  #-- calc summary
  summ <- summary(dataframe$cfish.data)
  
  #-- give lowercase names
  names(summ) <- c("min", "p25", "med", "mean", "p75", "max")
  
  return(summ)
}
# ___ (dataCFish_Summary) ____________________



# === [dataTime_Summary] ====================
dataTime_Summary <- function(dataframe) {
  
  # if (is.null(dataframe)) {
  #   
  #   #-- get dataframe type from TEST.Type
  #   if (get("TEST.Type.Exposure", envir = .GlobalEnv) == "Aqueous") {
  #     
  #     dataframe <- get("DATA.Aqueous.Work", envir = .GlobalEnv)
  #     
  #   } else {
  #     
  #     # assume these are the only current TEST.Types
  #     dataframe <- get("DATA.Dietary.Work", envir = .GlobalEnv)
  #   }
  # }
  
  #-- calc summary
  summ <- summary(dataframe$time.data)
  
  #-- give lowercase names
  names(summ) <- c("min", "p25", "med", "mean", "p75", "max")
  
  return(summ)
}
# ___ (dataTime_Summary) ____________________



# === [dataTrans_BoxCox] ====================
# --- FINAL bcmfR
# ~~~ check for NA
dataTrans_BoxCox <- function(datacfish,
                             lambda,
                             lnstarter = 1e-9) {
  
  #-- always do this on the working dataframe
  # dataframecfish <- DATA.Dietary.Work
  
  #-- use lnstarter value
  datacfish <- transform(datacfish, bc.cfish.data = car::bcPower(cfish.data + lnstarter,
                                                       lambda))  
  
  # calc.cfishBClam <- paste("calc.cfishBC", lucid(lambda,6), sep = "")
  # lengthnames <- length(names(dataframecfish))
  # names(dataframecfish)[lengthnames] <- calc.cfishBClam
  
  #-- overwrite the working dataframe
  # assign("DATA.Dietary.Work", datacfish, envir = .GlobalEnv)
  
  return(datacfish)
}
# ___ (dataTrans_BoxCox) ____________________



# === [dataTrans_Ln] ====================
# --- FINAL bcmfR
# ~~~ check for NA!
dataTrans_Ln <- function(datacfish,
                         lnstarter = 1e-9) {
  
  # stopifnot(exists("DATA.Aqueous.Work", envir = .GlobalEnv))
  
  #-- always do this on the working dataframe
  # dataframecfish <- DATA.Aqueous.Work
  
  #-- if calc.cfishLN exists already, save to .Last
  # if (max(str_detect(names(dataframecfish), "calc.cfishLN")) == 1)
  #-- save to .Last anyway
  # assign("DATA.Aqueous.Work.Last", dataframecfish, envir = .GlobalEnv)
  
  #-- Ln-transform cfish.data with starter value to prevent ln(0)
  datacfish <- transform(datacfish, ln.cfish.data = log(cfish.data + lnstarter))
  
  #-- overwrite the working dataframe
  # assign("DATA.Aqueous.Work", datacfish, envir = .GlobalEnv)
  
  return(datacfish)
}
# ___ (dataTrans_Ln) ____________________



# === [ReadTest_Aqueous] ====================
# --- FINAL bcmfR
# --- reads a .csvy file with YAML test metadata and CSV data
ReadTest_Aqueous <- function(file.aqueous.csvy) {
  
  ClearTest_Aqueous()

  ClearTest_Dietary()  

  #-- test for .csvy extension?? File exists??
  
  #-- store Test exposure type and filename
  assign("@TEST.Data", file.aqueous.csvy, envir = .GlobalEnv)
  
  assign("@TEST.Type", "Aqueous", envir = .GlobalEnv)
  
  
  #-- read data from .cvs file
  # testdata <- read.table(file.dietary.data,
  #                        comment.char = "#",
  #                        sep = ",",
  #                        header = TRUE)
  # 
  
  # use devtools::install_github("leeper/rio")
  
  # dataframe.aqueous.csvy <- rio::import(file.aqueous.csvy)     # RIO CSVY NOT STANDARD IMPORT
  dataframe.aqueous.csvy <- csvy::read_csvy(file.aqueous.csvy)   # bcmf_data-21.R !!
  
  
  # print(dataframe.aqueous.csvy)
  
  
  #!! assumes this is the order (check names from attributes?)
  names(dataframe.aqueous.csvy) <- c("time.data", "cfish.data")
  
  
  # print( names(dataframe.aqueous.csvy))
  
  
  #-- create or overwrite .Work
  assign("DATA.Aqueous.Work", dataframe.aqueous.csvy, envir = .GlobalEnv)
  
  BuildTest_Aqueous(file.aqueous.csvy) # builds param and var data frames
  
  cat("TEST.Aqueous.Design:")
  cat("\n")
  
  print(TEST.Aqueous.Design)
  cat("\n")
  
  cat("TEST.Aqueous.Measured:")
  cat("\n")
  
  print(TEST.Aqueous.Measured)
  cat("\n")
  
  cat("DATA.Aqueous.Work:")
  cat("\n")
  print(DATA.Aqueous.Work)
  
  #return(dataframe.aqueous.csvy)
  
}
# ___ (ReadTest_Aqueous) ____________________



# === [ReadTestData_Dietary] ====================
# --- FINAL bcmfR
# --- reads a .csvy file with YAML test metadata and CSV data
ReadTest_Dietary <- function(file.dietary.csvy) {
  
  ClearTest_Aqueous()

  ClearTest_Dietary()

  #-- test for .csvy extension?? File exists??
  
  #-- store Test exposure type and filename
  assign("@TEST.Data", file.dietary.csvy, envir = .GlobalEnv)
  
  assign("@TEST.Type", "Dietary", envir = .GlobalEnv)
  
  #-- read data from .cvs file
  # testdata <- read.table(file.dietary.data,
  #                        comment.char = "#",
  #                        sep = ",",
  #                        header = TRUE)
  # 
  
  # use devtools::install_github("leeper/rio")
  
  # dataframe.dietary.csvy <- rio::import(file.dietary.csvy)     # RIO CSVY NOT STANDARD IMPORT
  dataframe.dietary.csvy <- csvy::read_csvy(file.dietary.csvy)   # bcmf_data-24.R !!
  
  #!! assumes this is the order (check names from attributes?)
  names(dataframe.dietary.csvy) <- c("time.data", "cfish.data")
  
  #-- create or overwrite .Work
  assign("DATA.Dietary.Work", dataframe.dietary.csvy, envir = .GlobalEnv)
  
  BuildTest_Dietary(file.dietary.csvy)  # build param and var data frames
  
  
  cat("TEST.Dietary.Design:")
  cat("\n")
  
  print(TEST.Dietary.Design)
  cat("\n")
  
  cat("TEST.Dietary.Measured:")
  cat("\n")
  
  print(TEST.Dietary.Measured)
  cat("\n")
  
  cat("DATA.Dietary.Work:")
  cat("\n")
  print(DATA.Dietary.Work)
  
  # return(dataframe.dietary.csvy)
  
}
# ___ (ReadTestData_Dietary) ____________________




# # ==[setVarInfo]==========================================================
# # -- helper function to capture variable (column) information
# setVarInfo <- function(header    = "",
#                          userunit  = "",
#                          dimension = "",
#                          comments  = "") {
#   list(header    = header,
#        userunit  = userunit,
#        dimension = dimension,
#        comments  = comments)
# }
# # == setVarInfo =====.


# # ==[getFileInfoCFish]===================================================
# # -- builds one horizontal data frame; pretty print later
# getFileInfoCFish <- function() {
#   
#   #- this is a primitive print method, not yet S3
#   as.data.frame(get("File.Info.CFish", envir = .GlobalEnv))
# }
# # == getFileInfoCFish =====.



# # ==[set_file_info_cfish]===================================================
# # -- helper function; will be run by readDataCFish
# # -- result is stored in File.Info.CFish
# # -- empty setVarInfo() defines list structure
# set_file_info_cfish <- function(filename   = "",
#                                 datasource = "",
#                                 timeinfo   = setVarInfo(),
#                                 cfishinfo  = setVarInfo(),
#                                 comments   = "") {
#   #- 
#   fileinfocfish <- list(filename   = filename,
#                         datasource = datasource,
#                         timeinfo   = timeinfo,
#                         cfishinfo  = cfishinfo,
#                         comments   = comments)
#   
#   assign("File.Info.CFish", fileinfocfish, envir = .GlobalEnv)
#   
#   return(fileinfocfish)
# }
# # == set_file_info_cfish =====.














# # ==[set_file_info_test]=====================================================
# # -- helper function; will be run by readDataTest
# # -- result is stored in File.Info.Test
# # -- empty setVarInfo() defines list structure
# set_file_info_test <- function(filename   = "",
#                                datasource = "",
#                                cwaterinfo = setVarInfo(),
#                                tstartinfo = setVarInfo(),
#                                tdepurinfo = setVarInfo(),
#                                tendinfo   = setVarInfo(),
#                                comments   = "") {
#   #- 
#   fileinfotest <- list(filename   = filename,
#                        datasource = datasource,
#                        cwaterinfo = cwaterinfo,
#                        tstartinfo = tstartinfo,
#                        tdepurinfo = tdepurinfo,
#                        tendinfo   = tendinfo,
#                        comments   = comments)
#   
#   assign("File.Info.Test", fileinfotest, envir = .GlobalEnv)
#   
#   return(fileinfotest)
# }
# # == set_file_info_test =====.




# # ==[read_table_test]======================================================
# # -- helper function; hide in namespaces
# read_table_test <- function (fileinfotest)  {
#   #- check listtype fileinfocfish? not empty?
#   
#   #- read data frame from file; may contain unused columns,
#   #- and userdefined header names
#   tabletest <- read.table(fileinfotest$filename,
#                           comment.char="#",
#                           sep=",",
#                           header=TRUE)
#   
#   #-
#   columncwater  <- which(names(tabletest) == fileinfotest$cwaterinfo$header)
#   if(length(columncwater)==0)
#     stop("No such header for cwater info")
#   
#   #-
#   columntstart <- which(names(tabletest) == fileinfotest$tstartinfo$header)
#   if(length(columntstart)==0)
#     stop("No such header for tstart info.")
#   
#   #-
#   columntdepur <- which(names(tabletest) == fileinfotest$tdepurinfo$header)
#   if(length(columntdepur)==0)
#     stop("No such header for tdepur info.")
#   
#   #-
#   columntend <- which(names(tabletest) == fileinfotest$tendinfo$header)
#   if(length(columntdepur)==0)
#     stop("No such header for tend info.")
#   
#   #- headers are set to var.CWater, var.TStart, var.TDepur, var.TEnd
#   dataframetest <- data.frame(var.cwater = tabletest[[columncwater]][1],
#                               var.tstart = tabletest[[columntstart]][1],
#                               var.tdepur = tabletest[[columntdepur]][1],
#                               var.tend   = tabletest[[columntend]][1])
#   
#   setTestCWater(dataframetest$var.cwater) #, Userunit = "[ugX/L]", Comments = "average")
#   setTestTStart(dataframetest$var.tstart)
#   setTestTDepur(dataframetest$var.tdepur)
#   setTestTEnd(dataframetest$var.tend)
#     
#   return(dataframetest)
#   
# }
# # == read_table_test =====.



# # ==[readDataTest]=======================================================
# # -- does set_file_info_test and read_table_test in one sweep
# readDataTest <- function(filename   = "",
#                            datasource = "",
#                            cwaterinfo = setVarInfo(),
#                            tstartinfo = setVarInfo(),
#                            tdepurinfo = setVarInfo(),
#                            tendinfo   = setVarInfo(),
#                            comments   = "") {
#   
#   
#   #- sets the file info, column info, user units
#   fileinfotest <- set_file_info_test(filename   = filename,
#                                      datasource = datasource,
#                                      cwaterinfo = cwaterinfo,
#                                      tstartinfo = tstartinfo,
#                                      tdepurinfo = tdepurinfo,
#                                      tendinfo   = tendinfo,
#                                      comments   = comments)
#   
#   #- actually does the read.table 
#   dataframetest <- read_table_test(fileinfotest)
#   
#   assign("Data.Test", dataframetest, envir = .GlobalEnv)  
#   
# }
# # --(readDataTest)-----------------------------------------------------------.





# will be run by enterDataWFish
# setInfoWFish <- function(filename   = "",
#                          datasource = "",
#                          timeinfo   = setVarInfo(),
#                          infowfish  = setVarInfo(),
#                          comments   = "") {
#   assign("INFO.FILE.WFISH",
#          list(filename   = filename,
#               datasource = datasource,
#               timeinfo   = timeinfo,
#               infowfish  = infowfish,
#               comments   = comments),
#          envir = .GlobalEnv)
#   
# } # setInfoWFish.



# _________________________________________________________________________
# %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%