# %% bcmfR 0.3-1 R-source  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
# _________________________________________________________________________
#
#    bio_model_9.R
# _________________________________________________________________________
#
#    R-code to run BCF and BMF models

# MOVED TO bio_bcfjoint_21.R
# # === [modelRun_Aqueous] ====================
# # --- FINAL bcmfR
# # --- uses C0,d as parameter, instead of testparam vector
# modelRun_Aqueous <- function(time, testparam, park1, park2) {
#   
#   cwater <- testparam["cwater"]
#   tdep   <- testparam["tdepur"]
#   
#   term1  <- cwater*park1/park2
#   term2  <- term1*(exp(park2*tdep) - 1)
#   
#   cfish <- ifelse(time < tdep,
#                   term1*(1 - exp(-park2*time)),
#                   term2*exp(-park2*time))
#   
#   return(cfish)
# }
# # ___ (modelRun_Aqueous) ____________________


# === [run_Model_BCFK1K2] ====================
# --- FINAL bcmf
run_Model_BCFK1K2 <- function(time, cwater, tdep, park1, park2) {
  cfish <- ifelse(time < tdep,
                  cwater*park1/park2*(1 - exp(-park2*time)),
                  cwater*park1/park2*(exp(park2*tdep) - 1)*exp(-park2*time))
  return(cfish)
}
# ___ (run_Model_BCFK1K2) ____________________



# ++ todo: annotation for roxygen
modelCFishK1K2 <- function(time, cwater, tdep, park1, park2) {
  cfish <- ifelse(time < tdep,
                  cwater*park1/park2*(1-exp(-park2*time)),
                  cwater*park1/park2*(exp(park2*tdep)-1)*exp(-park2*time))
  return(cfish)
} # modelCFishK1K2.


# === Model.Run.CFish.K1K2 ================================================
# ~~~ keep
Model.Run.CFish.K1K2 <- function(time, cwater, tdep, park1, park2) {
  cfish <- ifelse(time < tdep,
                  cwater*park1/park2*(1-exp(-park2*time)),
                  cwater*park1/park2*(exp(park2*tdep)-1)*exp(-park2*time))
  return(cfish)
}
#---- Model.Run.CFish.K1K2 ------------------------------------------------





# ++ todo: annotation for roxygen
modelCFishBcfK2 <- function(time, cwater, tdep, parbcf, park2) {
  cfish <- ifelse(time < tdep,
                  cwater*parbcf*(1-exp(-park2*time)),
                  cwater*parbcf*(exp(park2*tdep)-1)*exp(-park2*time))
  return(cfish)
} # modelCFishBcfK2.


#=== Model.Run.CFish.BcfK2 ================================================:
Model.Run.CFish.BcfK2 <- function(time, cwater, tdep, parbcf, park2) {
  cfish <- ifelse(time < tdep,
                  cwater*parbcf*(1-exp(-park2*time)),
                  cwater*parbcf*(exp(park2*tdep)-1)*exp(-park2*time))
  return(cfish)
}
#~~~ Model.Run.CFish.BcfK2 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~.


#=== Model.Run.CFish.BcfK2.Uptake =========================================:
#--- no depuration phase; no growth
#-!- todo: annotation for roxygen

Model.Run.CFish.BcfK2.Uptake <- function(time, cwater, parbcf, park2) {
  
  #-- uptake phase model; 2-par: bcf and k2
  cfish <- cwater*parbcf*(1-exp(-park2*time))
  
  #-- return cfish
  cfish

}
#=== Model.Run.CFish.BcfK2.Uptake ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~.


#=== Model.Run.CFish.K1K2.Uptake ===========================================
#--- no depuration phase; no growth
#-!- todo: annotation for roxygen

Model.Run.CFish.K1K2.Uptake <- function(time, cwater, park1, park2) {
  
  # - uptake phase model with 2-params: k1 and k2
  cfish <- cwater*park1/park2*(1-exp(-park2*time))
  
  # - return cfish
  cfish
  
}
#=== Model.Run.CFish.K1K2.Uptake =====.


# ++ todo: annotation for roxygen
modelCFishBcfAlphaK2 <- function(time, cwater, tdep, parbcf, paralpha, park2) {
  cfish <- ifelse(time < tdep,
                  cwater*parbcf*(1-exp(-park2*time)),
                  exp(paralpha - park2*time))
  return(cfish)
} # modelCFishBcfAlphaK2.


# ++ todo: annotation for roxygen
modelCFishK1AlphaK2 <- function(time, cwater, tdep, park1, paralpha, park2) {
  cfish <- ifelse(time < tdep,
                  cwater*park1/park2*(1-exp(-park2*time)),
                  exp(paralpha - park2*time))
  return(cfish)
} # modelCFishK1AlphaK2.


# ++ todo: annotation for roxygen
modelCFishK1GammaK2 <- function(time, cwater, tdep, park1, pargamma, park2) {
  cfish <- ifelse(time < tdep,
                  cwater*park1/park2*(1-exp(-park2*time)),
                  exp(pargamma - park2*(time - tdep)))
  return(cfish)
} # modelCFishK1GammaK2.


#=== model.run.cfish.seq3 =================================================:
#-!- todo: annotation for roxygen
#-?- pargammaexp? cfish(t=tdep)=exp(gamma)
model.run.cfish.seq3 <- function(time, cwater, tdep,
                                 park1, pargamma, park2) {
  
  #-- time may be a vector with more than 1 element
  cfish <- ifelse(time < tdep,
                  cwater*park1/park2*(1-exp(-park2*time)),
                  exp(pargamma - park2*(time - tdep)))
  
  #-- return cfish vector
  return(cfish)
}
#~~~ model.run.cfish.seq3 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~.



# == model.run.cfish.seq3.ParBcf ===========================================
# ++ todo: annotation for roxygen
# model.run.cfish.seq3.ParBcf <- function(time, cwater, tdep,
#                                  parbcf, paralpha, park2) {
#   
#   #- time may be a vector
#   cfish <- ifelse(time < tdep,
#                   cwater*parbcf*(1-exp(-park2*time)),
#                   exp(paralpha - park2*time))
#   
#   #- return cfish vector
#   cfish
# }
# == model.run.cfish.seq3.ParBcf =====.

# __________________________________________________________________________
# %% END OF R-Source %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%